unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, IBCustomDataSet, IBQuery, IBDatabase;

type
  TForm1 = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// N
procedure TForm1.FormShow(Sender: TObject);
begin
   // NɃf[^x[X쐬܂
   IBDataBase1.DatabaseName := Edit1.Text + Edit2.Text + 'TEST1.FDB' ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER "SYSDBA"');
   IBDatabase1.Params.Add('PASSWORD "masterkey"');
   IBDatabase1.Params.Add('PAGE_SIZE 4096');
   try
      IBDataBase1.CreateDatabase;
   except
      // ɍ쐬ς
   end;
end;

// I
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Button2Click(Sender);   // DBؒf
end;

// [DBڑ]
procedure TForm1.Button1Click(Sender: TObject);
begin
   // f[^x[Xڑ
   IBDataBase1.DatabaseName := Edit1.Text + Edit2.Text + 'TEST1.FDB' ;
   IBDataBase1.Connected := False ;
   IBDatabase1.Params.Clear ;
   IBDatabase1.Params.Add('USER_NAME=SYSDBA');
   IBDatabase1.Params.Add('PASSWORD=masterkey');
   try
      IBDatabase1.Connected := True ;
   except
      Button2Click(Sender) ;  // G[ؒf
      exit ;
   end;
   // e[u쐬
   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('CREATE TABLE TEST1 (' );
         Add('  N INTEGER NOT NULL UNIQUE,');
         Add('  MOJIDATA VARCHAR(20)');
         Add('  );');
      end;
      if not(IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
   except
      IBTransaction1.Rollback ;
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// [DBؒf]
procedure TForm1.Button2Click(Sender: TObject);
begin
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBDatabase1.Connected := False ;
end;

// [o^]
procedure TForm1.Button3Click(Sender: TObject);
var
   i,j : integer ;
   p1,p2 : string ;
begin
   if not(IBDatabase1.Connected) then exit ;
   i := 0;
   if (Edit3.Text <> '') then begin
      Val(Edit3.Text,i,j);
      if (j <> 0) then i := 0;
   end;
   p1 := IntToStr(i);
   p2 := Edit4.Text ;
   if (AnsiPos('''',p2) > 0)or(AnsiPos('"',p2) > 0) then begin
      ShowMessage('MOJIDATAɁu''vu"v͎gȂł');
      Edit4.SetFocus;
      exit ;
   end;
   if (p2 = '') then
      p2 := 'NULL'
   else
      p2 := '''' + p2 + '''' ;

   try
      IBTransaction1.Active := False ;
      IBTransaction1.StartTransaction ;
      IBQuery1.Close;
      IBQuery1.ParamCheck := False ;
      with IBQuery1.SQL do begin
         Clear ;
         Add('INSERT INTO TEST1 (');
         Add('  N, MOJIDATA)');
         Add('VALUES (');
         Add('  ' + p1 + ',');
         Add('  ' + p2 + ');');
      end;
      if not (IBQuery1.Prepared) then IBQuery1.Prepare;
      IBQuery1.ExecSQL;
      IBTransaction1.Commit;
      ShowMessage('o^OK');
   except
      IBTransaction1.Rollback ;
      ShowMessage('o^s');
   end;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
end;

// [\]
procedure TForm1.Button4Click(Sender: TObject);
var
   s : string ;
begin
   if not(IBDatabase1.Connected) then exit ;
   Memo1.Lines.Clear ;
   IBQuery1.Active := False ;
   IBTransaction1.Active := False ;
   IBQuery1.ParamCheck := True ;
   with IBQuery1.SQL do begin
      Clear ;
      Add('SELECT * FROM TEST1;') ;
   end;
   //
   try
      IBQuery1.Open ;
      IBQuery1.First ;
      while not(IBQuery1.Eof) do begin
         s := IBQuery1.Fields[0].AsString + ','
            + IBQuery1.Fields[1].AsString;
         Memo1.Lines.Add(s);
         IBQuery1.Next ;
      end;
   except
      ;
   end;
   IBQuery1.Active := False ;
end;

end.
